#ifndef PSM_KDC_NOPSMDRM_H
#define PSM_KDC_NOPSMDRM_H

#include <android/log.h>
#define LOG(...) __android_log_print(ANDROID_LOG_DEBUG, "LIBDEFAULTPROXY", __VA_ARGS__)
#define LOGFUNCTION() __android_log_print(ANDROID_LOG_DEBUG, "LIBDEFAULTPROXY", "%s", __FUNCTION__)
#define LOGBUF(buffer, buffer_sz) char buf[buffer_sz * 3 + 2]; \
								  char *out_p = buf;\
								  const unsigned char *const in_p = (void*)buffer;\
								  for (int i = 0; i < buffer_sz; i++) { \
									sprintf(out_p, " %02x", in_p[i]); \
									out_p += 3; \
								  } \
								  LOG("%s", buf);


typedef struct
{
    char magic[0x8];             // 0x00
    uint32_t unk1;               // 0x08
    uint32_t unk2;               // 0x0C
    uint64_t aid;                // 0x10
    uint32_t unk3;               // 0x18
    uint32_t unk4;               // 0x1C
    uint64_t start_time;         // 0x20
    uint64_t expiration_time;    // 0x28
    uint8_t act_digest[0x20];    // 0x30
    char content_id[0x30];       // 0x50
    uint8_t unk5[0x80];          // 0x80
    uint8_t key[0x200];          // 0x100
    uint8_t sha256digest[0x100]; // 0x300
} ScePsmDrmLicense;


int patch_libdefault(void* handle);

#endif //PSM_KDC_NOPSMDRM_H
